#include "batch.h"
#include "error.h"
#include "immediate.h"

namespace Msp {
namespace GL {

Immediate::Immediate(VertexFormat f):
	PrimitiveBuilder(array),
	array(f)
{
	array.use_buffer(0);
}

void Immediate::reset()
{
	if(in_batch)
		throw invalid_operation("Immediate::reset");

	array.clear();
}

void Immediate::begin_()
{
	indices.clear();
}

void Immediate::end_()
{
	Batch batch(type);
	batch.append(indices);
	array.apply();
	batch.draw();
}

void Immediate::element_(unsigned i)
{
	indices.push_back(i);
}

} // namespace GL
} // namespace Msp
